//import your libraries. 
import de.bezier.data.sql.*;

MySQL msql;
MySQL msql2;
MySQL msql3;
MySQL msql4;
MySQL msql5;
MySQL msql6;
PFont font1 = createFont("Helvetica", 16); //"Helvetica" the documentary <-- netflix 
int border = 29;
int scaleFactor = 10;
int spacing = 125;
float lineWidth = 25.0;

int[] debt = new int[2100];
int[] invest = new int[2100];
int[] realEstate = new int[2100];
int[] total = new int[2100];

void setup() {
  size(900, 640); //size of the sketch window
  colorMode(HSB, 100, 200, 200); //color mode- like RGB or HSB (learn to use HSB because it's the best: http://en.wikipedia.org/wiki/HSL_and_HSV)
  smooth();


  // connecting to database
  msql = new MySQL( this, "tango.mat.ucsb.edu", "spl0", "mat259", "V1sual1zat1on" ); //host, database, user, password
  if ( msql.connect() )
  { 
    String TheQuery="select year(cout) as year,count(*) from inraw where title like '%debt%' and deweyClass != 'null' and year(cout) >= '2006' group by year order by year;";
    //      String TheQuery="select year(cout) as year,count(*) from inraw where deweyClass < 1000 and cout >= '2011-01-01' and cout <= '2011-01-31' group by year order by year;";
    println(TheQuery);
    msql.query( TheQuery);
    //msql.next();
    while ( msql.next () ) {
      println( msql.getInt(1) );
      debt[msql.getInt(1)] = msql.getInt(2);
    }
    /*
    for(int i = 0;i<2000;i++) {
     println(debt[i]);
     }
     */
  }
  else
  {
    println("Connection failed");
  }

  msql2 = new MySQL( this, "tango.mat.ucsb.edu", "spl0", "mat259", "V1sual1zat1on" ); //host, database, user, password
  if ( msql2.connect() )
  { 
    String TheQuery2="select year(cout) as year,count(*) from inraw where title like '%invest%' and deweyClass != 'null' and year(cout) >= '2006' group by year order by year;";
    //      String TheQuery="select year(cout) as year,count(*) from inraw where deweyClass < 1000 and cout >= '2011-01-01' and cout <= '2011-01-31' group by year order by year;";
    println(TheQuery2);
    msql2.query( TheQuery2);
    //msql2.next();
    while ( msql2.next () ) {
      println( msql2.getInt(1) );
      invest[msql2.getInt(1)] = msql2.getInt(2);
    }
  }
  else
  {
    println("Connection failed");
  }

  msql3 = new MySQL( this, "tango.mat.ucsb.edu", "spl0", "mat259", "V1sual1zat1on" ); //host, database, user, password
  if ( msql3.connect() )
  { 
    String TheQuery3="select year(cout) as year,count(*) from inraw where title like '%real estate%' and deweyClass != 'null' and year(cout) >= '2006' group by year order by year;";
    //      String TheQuery="select year(cout) as year,count(*) from inraw where deweyClass < 1000 and cout >= '2011-01-01' and cout <= '2011-01-31' group by year order by year;";
    println(TheQuery3);
    msql3.query( TheQuery3);
    //msql3.next();
    while ( msql3.next () ) {
      println( msql3.getInt(1) );
      realEstate[msql3.getInt(1)] = msql3.getInt(2);
    }
  }
  else
  {
    println("Connection failed");
  }

  msql4 = new MySQL( this, "tango.mat.ucsb.edu", "spl0", "mat259", "V1sual1zat1on" ); //host, database, user, password
  if ( msql4.connect() )
  { 
    String TheQuery4="select year(cout) as year, count(*) from inraw where deweyClass != 'null' and year(cout) >= '2006' group by year order by year;";
    //      String TheQuery="select year(cout) as year,count(*) from inraw where deweyClass < 1000 and cout >= '2011-01-01' and cout <= '2011-01-31' group by year order by year;";
    println(TheQuery4);
    msql4.query( TheQuery4);
    msql4.next();
    while ( msql4.next () ) {
      println( msql4.getInt(1) );
      total[msql4.getInt(1)] = msql4.getInt(2);
    }
  }
  else
  {
    println("Connection failed");
  }
}

void draw() {
  int curX = 0;
  int curY = 0;
  int newX = 0;
  int newY = 0;

  int graphYOffset = height-77;
  
  background(99);
    fill(10, 100, 100, 150);
  strokeCap(SQUARE);
  // "
  //draw lines for no. of transactions
  // debt 
  stroke(130, 150, 300, 150);  
  strokeWeight(lineWidth);
  for (int i = 1;i<7;i++) {
    //      line(border,(i+1)*(height/24),border+transactionsPerHour[i]/10,(i+1)*(height/24));
    line(i*spacing, graphYOffset-(debt[i+2005]/scaleFactor)/2, i*spacing, graphYOffset);
    //text(i, border-2,(i+1)*(height/24));
  }
  

  //invest 
  stroke(200, 100, 20, 150);  
  strokeWeight(lineWidth);
  for (int i = 1;i<7;i++) {
    //      line(border,(i+1)*(height/24),border+transactionsPerHour[i]/10,(i+1)*(height/24));
    line((i*spacing)+30, graphYOffset-(invest[i+2005]/scaleFactor)/2, (i*spacing)+30, graphYOffset);
    //text(i, border-2,(i+1)*(height/24));
  }
 
  //real estate 
  stroke(20, 130, 60, 150);  
  strokeWeight(lineWidth);
  for (int i = 1;i<7;i++) {
    //      line(border,(i+1)*(height/24),border+transactionsPerHour[i]/10,(i+1)*(height/24));
    line((i*spacing)+60, graphYOffset-(realEstate[i+2005]/scaleFactor)/2, (i*spacing)+60, graphYOffset);
    textAlign(RIGHT, CENTER);
    //text(i, border-2,(i+1)*(height/24));
  }

  //draw the year (horizontal) labels 
  for (int i =2006;i<2012;++i) {
    float tempX = 45+(i-2005)*125;
    float tempY = height-120;
    textSize(13);
    fill(10, 100, 100, 120);
    text(i, tempX, graphYOffset+14);
  }

  //draw the financial crisis related titles' (vertical) labels 
  for (int i = 0;i<110;i++) {
    if(i % 10 == 0)
    {
    float tempY = graphYOffset;
    textSize(10);
    fill(100, 250, 50, 120);
    text(i*scaleFactor*scaleFactor, border+30, tempY-i*scaleFactor/2);
    }
  }

  fill(100, 50, 50, 120);
  textAlign(LEFT, BOTTOM);
  textSize(15);
  text("Seattle Public Library, Transaction Titles: 2006-2011", border+7, height-15); 
  fill(130, 150, 300, 150);  
  text("Debt", width-border-82, height-15);
  fill(200, 100, 30, 150);  
  text("Invest", width-border-150, height-15);
  fill(20, 130, 60, 150);  
  text("Real Estate", width-border-253, height-15);
}

